#ifndef __MLC_H__
#define __MLC_H__

#include <vstypes.h>

/*
  Note: These settings assume there are at least 4 working erase blocks
        in the last 64 erase blocks of the FLASH (RESERVED_AREA), and
	max 128 erase blocks are bad.
  NOTE: These defines are NOT freely adjustable!
 */
#define RESERVED_AREA 64
#define MAX_ERASEBLOCKSIZE 1024
#define MAX_BADS 128      /* 128 erase blocks -- only whole erase blocks */
#define MAXREPL  6

//#define DIRECT_WRITE /* write to original block if possible */

#ifdef ASM

#define MLC_RETRIES 0 /*offset to retries field*/

#else

//s_int16 LargePageWrite(s_int32 page, u_int16 *data, u_int16 *meta);
//s_int16 LargePageRead(s_int32 page, u_int16 *data, u_int16 *meta);
u_int16 GetBitArray(register __i0 u_int16 *array, register __a0 int bit);
void SetBitArray(register __i0 u_int16 *array, register __a0 int bit);
void ClearBitArray(register __i0 u_int16 *array, register __a0 int bit);


struct REPL {
    u_int16 *data;
    u_int32 orig;     /*original physical*/
    u_int32 new;      /*new/journal physical*/
    u_int32 logical;  /*logical sector at start of erase block*/
    u_int16 time;
    u_int16 bits;
#ifdef DIRECT_WRITE
    u_int16 wrDirect; /*write pointer for original block*/
#endif
    u_int16 wrPtr; /*write pointer*/
    u_int16 inOrder;  /*if journal blocks are in order */

    u_int32 sector;
    u_int32 phys;
    u_int16 se;
    u_int16 mask;

    u_int16 replbitmap[MAX_ERASEBLOCKSIZE/16/4]; /*8 words for eraseblocksize 512*/
};
extern u_int16 fmfCache[6*1024];
struct MLC {
    u_int16 retries;    /* should be the first entry! */
    u_int32 dataStart;
    u_int16 rootBlock;  /*fits in 16 bits*/
    u_int32 dataBlocks; /*data size*/
    u_int16 bads;
    u_int16 bad[MAX_BADS];
    u_int16 badsChanged;

    u_int16 replaced;
    struct REPL replace[MAXREPL];
};

extern struct MLC mlc;
#endif/*else ASM*/

#endif/*__MLC_H__*/
