#define ASM
#include <vs1000.h>
#include "mlc.h"

//#include <vsNand.h>
#define NAND_OP_READ_SIGNATURE 0x90
#define NAND_OP_READ_STATUS 0x70
#define NAND_OP_READ_A 0x00
#define NAND_OP_READ_C 0x50
#define NAND_OP_COMMIT_DATA_ADDRESS 0x30
#define NAND_OP_PREPARE_TO_PROGRAM 0x80
#define NAND_OP_PERFORM_PROGRAM 0x10

	.import _fsNandPhys
	.import _NandSetWaits,_NandPutCommand,_NandSwapBad,_NandGetOctets
	.import _NandGetStatus,_NandPutDataAddress,_NandMingle,_CountBitsLong

#if 1
// s_int16 LargePageRead(s_int32 page, u_int16 *data, u_int16 *meta) {

	.sect code,LargePageRead	// 161 words
	.export _LargePageRead
_LargePageRead:	// PROLOGUE
	ldx (I6)+1,NULL	// Room for Sp and Fp
	stx MR0,(I6)+1 ; sty I2,(I6)
	stx LR0,(I6)+1 ; sty I1,(I6)	// return address
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+7,I4	// FP' = SP, reserve space
	ldx (I6)+3,NULL ; ldy (I4)+1,NULL
	ldc 512,MR0
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6)+1 ; sty C0,(I6)
	stx C1,(I6)+1 ; sty D0,(I6)
	stx D1,(I6)+1 ; sty I0,(I6)
	stx I3,(I6)+1 ; sty LC,(I6)
	stx LE,(I6) ; sty LS,(I6)

//   s_int16 err = 0;
//   __y s_int16 reread = 0;
//   __y u_int32 ecc[4];
//   register __c0 u_int16 n;
//   register __i3 u_int16 *d;
//   register __i1 u_int16 *m;

	and a0,null,a0
	stx A0,(I4) ; sty A0,(I4)-1	// err reread i4:+1

_LargePageRead_tryAgain:
// tryAgain:
//   d = data;
//   m = meta;
//   PERIP(GPIO0_SET_MASK) = GPIO0_CS1;
//   NandSetWaits(fsNandPhys.waitns);
//   PERIP(GPIO0_CLEAR_MASK) = GPIO0_CS1;
//   NandPutCommand(NAND_OP_READ_A 0x00 );

	ldc GPIO0_SET_MASK,I0
	ldc GPIO0_CS1,A1
	STP A1,(I0)+(GPIO0_CLEAR_MASK-GPIO0_SET_MASK)/*V*/	; ldy (i4)-5,null
	ldx (I4)-1,I3	// data i4:-5
	ldx (I4)+2,I1	// meta i4:-6

	ldc _fsNandPhys+12,I2
	call _NandSetWaits	// Register parameter: A0
	ldx (I2),A0

	call _NandPutCommand	// Register parameter: A0, pass by value
	STP A1,(I0)/*V*/ ; and NULL,NULL,A0

//   NandPutDataAddress(page & ~3L);
//   NandPutCommand(NAND_OP_COMMIT_DATA_ADDRESS 0x30 );

	ldc 0xfffc,A0
	ldx (I4)+1,C0
	ldx (I4)+3,C1
	call _NandPutDataAddress	// Register parameter: C
	and C0,A0,C0	; mv I4,I2	// ecc

	call _NandPutCommand	// Register parameter
	ldc NAND_OP_COMMIT_DATA_ADDRESS,A0

//   {
//       register __i2 __y u_int32 *e = &ecc[0];

	ldc 4-1,LS
	loop LS,LE5-1
	ldx (I2)+2,NULL

//       for (n=0;n<4;n++) {
// 	  PERIP(NFLSH_DSPIF) = NFLSH_DF_ECC_RESET;
// 	  NandGetOctets(512, d);

	ldc NFLSH_DSPIF,I0
	ldx (I6)+1,NULL ; sub NULL,ONES,A0
	STP A0,(I0)+(NFLSH_LPL-NFLSH_DSPIF)/*V*/ ; sty I2,(I6)
	mv I3,I2
	call _NandGetOctets	// Register parameter: I2, C0
	ldc 512,C0

// 	  d += 512/2;
// 	  *e++ = GET_ECC; (*(u_int32 *)NFLSH_LPL)

	ldc 256,I2
#ifdef PERIP_IN_X
	LDP (I0)+1,A0 ; ldy (I3)*,NULL	// I2 restored
	LDP (I0)-1,A1 ; ldy (I6)-1,I2
#else
	LDP (I0)+1,A0 ; ldx (I3)*,NULL	// I2 restored
	LDP (I0)-1,A1
	ldy (I6)-1,I2
#endif
	sty A0,(I2)+1
	sty A1,(I2)+1
LE5:

//       }
//   }
//   d -= 4*512/2;
//   NandGetOctets(4*16, m);

	mv i1,c0
	add c0,null,c0	//if meta is NULL, 0 loops
	ldc -4*512/2,I2
	jzs LC8
	ldx (I3)*,NULL

	mv I1,I2
	call _NandGetOctets	// Register parameter: I2, C0
	ldc 64,C0


//   {
//       register __i2 __y u_int32 *e = &ecc[0];
//       for (n=0;n<4;n++)

	ldc 4,c0
	j LC8
	mv I4,I2

L8:	// FOR body
//  {
// 	  register __b u_int32 xored;
// 	  NandSwapBad(m);

	call _NandSwapBad	// Register parameter: I0, pass by value
	mv I1,I0

// 	  xored = (((u_int32)(m[1] & 0xff00U)<<8) | m[0]) ^ *e++;

	ldx (I1)+1,null
	and B1,NULL,B1	; ldx (I1)-1,B0
	ldc 8,A0
	ashl B,A0,B	; ldy (I2)+1,A0
	ldx (i1)+1,B0	; ldy (I2)-1,A1
	xor B,A,B	; ldx (i6)+1,null
	stx i2,(i6)	; ldy (i1)+7,null
	jzs LE19
	nop

#if 0
	ldx (i6)+1,null
	stx b0,(i6)+1
	stx b1,(i6)
	.import _puthex,_putchar
	call _puthex
	nop
	ldx (i6)-1,b1
	call _puthex
	nop
	call _putchar
	ldc 0x0a,a0

	ldx (i6)-1,b0
#endif


// 	  if (xored) {
// 	      register __c1 s_int16 oneBits = CountBitsLong(xored);

	call _CountBitsLong	// Register parameter: A, pass by value
	ldx (I4)+1,NULL	; add B,null,A

#if 0
	.import _puthex,_putchar
	ldx (i6)+1,null
	call _puthex
	stx a0,(i6)
	call _putchar
	ldc 0x0a,a0
	ldx (i6)-1,a0
#endif


	ldc 4/*3*/,A1
	add A0,NULL,C1	; ldy (I4),A0		//reread
	sub A0,ONES,A0
	sub A0,A1,A1	; sty A0,(I4)-1
	//ldc _fsNandPhys+12,I0
	.import _mlc
	ldc _mlc+MLC_RETRIES,I0
	jgt L14	// >
	add C1,ONES,A0	// compare 1

// 	      if (++reread <= 3) {
// 	      again:
// 		  mlc.retries += 1; //fsNandPhys.waitns += 1;
// 		  if ((PERIP(NFLSH_CTRL) & 31) < 30)
// 		      PERIP(NFLSH_CTRL) += 2;
// 		  goto tryAgain;

	ldx (I0),A0 ; sub NULL,ONES,A1
	ldc NFLSH_CTRL,I7
	add A0,A1,A0	; LDP (I7),C1/*V*/

	ldc 31,A1
	and C1,A1,A0	//; stx A0,(I0)
	add A1,ONES,A1
	sub A0,A1,A1	; ldx (i6)-1,i2
	ldc 2,A1
	jcs _LargePageRead_tryAgain	// >=
	add C1,A1,A1

	j _LargePageRead_tryAgain
	STP A1,(I7)/*V*/
L14:

// 	      }
// 	      if (oneBits == 1)

	ldc 12,A0
	jzs LE19	// !=
	nop

//  {
// 	      } else if (oneBits != 12)

	sub C1,A0,A0 ; ldx (I4)+1,NULL
	ldc -1,A0
	jzs L20	// ==
	nop

//  {
// 		  err = -1;

	j LE19
	stx A0,(I4)-1	// err

L20:

// 	      } else {
// 		  register __a0 int line = NandMingle(xored);
// 		  register __a1 int col = (((line & 1) ^ 1) << 3) | (line >> 9);

	call _NandMingle	// Register parameter: A, pass by value
	ldx (I4)-1,NULL ; add B,NULL,A

#if 0
	.import _puthex,_putchar
	ldx (i6)+1,null
	call _puthex
	stx a0,(i6)
	call _putchar
	ldc 0x0a,a0
	ldx (i6)-1,a0
#endif

	sub NULL,ONES,A1
	and A0,A1,A1	; mv A1,D0
	xor A1,D0,A1
	ldc 3,D0
	ashl A1,D0,A1
	ldc -9,D1
	ashl A0,D1,D0
	asr A0,A0
	ldc 255,D1
	or A1,D0,A1
	sub NULL,ONES,D0
	and A0,D1,A0 ; mv I3,D1

// 		  line = (line >> 1) & 0xff;
// 		  d[line] ^= 1<<col;

	add D1,A0,D1
	ashl D0,A1,D0	; mv D1,I5
	ldx (I5),D1
	xor D1,D0,D0
	stx D0,(I5)
LE19:

// 	      }
// 	  }
// 	  d += 512/2;

	ldc 256,I2
	ldx (i6)-1,i2	; ldy (I3)*,NULL

	// FOR update expression (continue)
LC8:
	add C0,ones,C0	; ldx (i2)+2,null
	ldc GPIO0_SET_MASK,I0
	jnc L8	// <
	ldc GPIO0_CS1,A0

//       }
//   }
//   PERIP(GPIO0_SET_MASK) = GPIO0_CS1;
//   return err;

	STP A0,(I0)/*V*/ ; ldy (I4)+1,NULL
	ldx (I4)-1,A0	// err

	ldx (I6)-1,LE ; ldy (I6),LS
	ldx (I6)-1,I3 ; ldy (I6),LC
	ldx (I6)-1,D1 ; ldy (I6),I0
	ldx (I6)-1,C1 ; ldy (I6),D0
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),I1
	jr
	ldx (I6)-1,MR0 ; ldy (I6),I2
#else
	.sect code,LargePageRead	// 179 words
	.export _LargePageRead
_LargePageRead:	// PROLOGUE
	ldx (I6)+1,NULL	// Room for Sp and Fp
	stx MR0,(I6)+1 ; sty I7,(I6)
	stx LR0,(I6)+1 ; sty I5,(I6)	// return address
	stx I6,(I6) ; sty I4,(I6)
	ldx (I6)+7,I4	// FP' = SP, reserve space
	ldx (I6)+2,NULL ; ldy (I4)+1,NULL
	ldc 512,MR0
	stx A1,(I6)+1 ; sty B0,(I6)
	stx B1,(I6)+1 ; sty C0,(I6)
	stx C1,(I6)+1 ; sty D0,(I6)
	stx D1,(I6)+1 ; sty I0,(I6)
	ldc _fsNandPhys+12,I0
	stx I1,(I6)+1 ; sty I2,(I6)
	stx LE,(I6)+1 ; sty LS,(I6)
	stx LC,(I6) ; and NULL,NULL,C0

// extern struct FsNandPhys fsNandPhys;
// s_int16 LargePageWrite(u_int32 page, u_int16 *data, u_int16 *meta);
// s_int16 LargePageRead(s_int32 page, u_int16 *data, u_int16 *meta) {
//   register u_int16 n = 0;
//   s_int16 err = 0;
//   s_int16 reread = 0;
//   __y u_int32 ecc[4];

	// C0
	// allocated C0 as n
	and NULL,NULL,A0
	stx A0,(I4)+1	// err
	stx A0,(I4)-2	// reread

//   NandSetWaits(fsNandPhys.waitns);

	// Register parameter: A0, pass by value
	// field waitns, offset 12
	call _NandSetWaits
	ldx (I0),A0
// jumped away

// tryAgain:

_LargePageRead_tryAgain:

//   *((__x volatile u_int16 *)(u_int16)(  0xC046   ))   = 0x0400  ;

	ldc 1024,A0
	ldc 49222,I0
	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC046   ))   = 0x0400  ;

	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC046   ))   = 0x0400  ;

	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC046   ))   = 0x0400  ;

	stx A0,(I0)+1/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC047   ))   = 0x0400  ;

	// const -1 in I0
	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC047   ))   = 0x0400  ;

	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC047   ))   = 0x0400  ;

	stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC047   ))   = 0x0400  ;


//   NandPutCommand(0x00 );

	// Register parameter: A0, pass by value
	call _NandPutCommand
	stx A0,(I0)/*V*/ ; and NULL,NULL,A0
// jumped away
	// safe: I0

//   NandPutDataAddress(page & ~3L);

	ldc lo(-4),A0
	ldx (I6)+1,NULL ; ldy (I4)-4,NULL	// C already allocated
	sty C0,(I6) ; ldx (I4)+1,C0
	// Register parameter: C, pass by value
	// page
	ldx (I4)+3,C1 ; add NULL,ONES,A1
	call _NandPutDataAddress
	and C,A,C
// jumped away
	ldc 48,A0
	// safe: I0 A

//   NandPutCommand(0x30 );

	// Register parameter: A0, pass by value
	call _NandPutCommand
	ldy (I6)-1,NULL	// C restored
// jumped away
	// safe: I0

//   for (n=0;n<4;n++)

	// 4 loops
	// n read inside loop 1
	ldc 3,LS
	loop LS,LE5-1
	ldc 0,C0
//loop resumes
//  {
//       *((__x volatile u_int16 *)(u_int16)(  0xC065   ))   = (1<<0) ;

	ldc 49253,I0
	ldc 256,A1
	ldx (I6)+1,NULL ; sub NULL,ONES,A0
	stx A0,(I0)/*V*/ ; sty C0,(I6)

//       NandGetOctets(512, data);

	// C0 already allocated
	// Register parameter: I2, pass by value
	ldc 512,C0
	ldx (I4)-5,NULL
	// Register parameter: C0, pass by value
	call _NandGetOctets
	ldx (I4)+5,I2	// data
// jumped away
	ldy (I6)-1,C0 ; ldx (I4)-5,NULL	// C0 restored
	mv I4,I1	// data
	// safe: I0

//       data += 512/2;

	ldx (I4)+6,A0 ; ldy (I0)-4,NULL
	mv I4,B0	// ecc
	add A0,A1,A1 ; ldx (I4)-1,NULL
	stx A1,(I1) ; add B0,C0,B0

//       ecc[n] = (*(u_int32 *)0xC061 ) ;

	// const +4 in I0
	ldx (I0)+1,A0 ; add B0,C0,B0
	ldx (I0)-1,A1
	// #1 [] element size 2
	mv B0,I5 ; sub C0,ONES,C0
	sty A0,(I5)+1
	sty A1,(I5)-1
	// FOR update expression (continue)
// 0 NOP's needed
// loop end
LE5:

//   }
//   data -= 4*512/2;

	ldc 1024,A1
	ldx (I4)-5,NULL ; ldy (I6)+1,NULL
	mv I4,I0	// data
	ldx (I4)+5,A0 ; ldy (I0)-1,NULL
	sub A0,A1,A1 ; ldx (I0)+1,A0
	stx A1,(I0)-1 ; add A0,NULL,A0

//   if (!meta)

	// stack variable meta address +1 in I0
	// update flags
	mv A0,I2
	jzs _LargePageRead_out
	ldc 1024,A0	// C0 already allocated
// jumped away

//       goto out;


//   NandGetOctets(4*16, meta);

	sty C0,(I6)
	// Register parameter: I2, pass by value
	// expression in A0
	// Register parameter: C0, pass by value
	call _NandGetOctets
	ldc 64,C0
// jumped away
	// safe: A0 A1

//   for (n=0;n<4;n++)

	// can't: goto(s) inside loop
	j LC10
	ldy (I6)-1,NULL ; and NULL,NULL,C0	// C0 restored
// jumped away
L10:	// FOR body
//  {
//       register u_int32 xored;
//       NandSwapBad(meta);

	ldc 65280,A0
	call _NandSwapBad
	ldx (I4)+6,I0	// meta
// jumped away

//       xored = (((u_int32)(meta[1] & 0xff00U)<<8) | meta[0]) ^ ecc[n];

	ldx (I4)-6,NULL ; and B1,NULL,B1
	ldx (I4)+7,I0 ; and A1,NULL,A1	// meta
	ldx (I0)+1,NULL
	ldx (I0)-1,B0
	and B0,A0,B0 ; mv I4,C1
	ldc 8,A0
	ashl B,A0,B ; ldx (I0),A0
	or B,A,B ; ldx (I4)-1,NULL
	add C1,C0,C1
	add C1,C0,C1
	mv C1,I5
	ldy (I5)+1,A0
	ldy (I5)-1,A1
	xor B,A,B

//       if (xored
// 	  )

	nop
	jzs LE21
	nop
// jumped away
//  {
// 	  register s_int16 oneBits = CountBitsLong(xored);

	// C1
	// allocated C1 as oneBits
	// Register parameter: A, pass by value
	// expression in B
	call _CountBitsLong
	add B,NULL,A

	ldc 2,A1
	ldx (I4)+2,NULL ; add A0,NULL,C1
	mv I4,I0	// reread

// 	  if (++reread <= 2)

	ldx (I4)-2,A0
	sub A0,ONES,A0
	stx A0,(I0) ; sub A0,A1,A1
	nop
	jgt L16	// >
	add C1,ONES,A0	// compare 1

//  {
// 	    if ((*((__x volatile u_int16 *)(u_int16)(  0xC060   ))   & 31) < 30)

	ldc 49248,I1
	ldc 31,A1
	ldx (I1),A0/*V*/
	and A0,A1,A0
	add A1,ONES,A1
	sub A0,A1,A1
	ldc 2,A1
	jcs _LargePageRead_tryAgain	// >=
	nop

// 		*((__x volatile u_int16 *)(u_int16)(  0xC060   ))   += 2;
// 	    goto tryAgain;

	ldx (I1),A0/*V*/
	add A0,A1,A1
	j _LargePageRead_tryAgain
	stx A1,(I1)/*V*/
L16:

// 	  }
// 	  if (oneBits == 1)

	ldc 12,A0
	jzs LE21	// !=
	sub C1,A0,A0 ; ldx (I0)-1,NULL
//  {
// 	  } else if (oneBits != 12)

	ldc -1,A0
	jzs L22	// ==
	nop
//  {
// 	      err = -1;

	j LE21
	stx A0,(I0)
L22:

// 	  } else {
// 	      register int line = NandMingle(xored);
// 	      register int col = (((line & 1) ^ 1) << 3) | (line >> 9);
// 	      line = (line >> 1) & 0xff;
// 	      data[line] ^= 1<<col;

	ldc 65527,D1
	call _NandMingle
	ldx (I0)+1,NULL ; add B,NULL,A

	sub NULL,ONES,D0 ; ldx (I0)-7,NULL
	sub NULL,ONES,A1
	and A0,A1,A1
	xor A1,D0,A1
	ldc 3,D0
	ashl A1,D0,A1
	ashl A0,D1,D0
	asr A0,A0
	ldc 255,D1
	or A1,D0,A1
	sub NULL,ONES,D0

	and A0,D1,A0 ; ldx (I0),D1
	add D1,A0,D1	// #1 [] element size 1
	mv D1,I1 ; ashl D0,A1,D0
	ldx (I1),D1
	xor D1,D0,D0
	stx D0,(I1)
LE21:
// 	  }
//       }
//       data += 512/2;
//       meta += 16/2;

	ldc 256,A1
	ldx (I4)-5,NULL ; sub C0,ONES,C0
	mv I4,I0	// data
	ldx (I4)-1,A0
	add A0,A1,A1 ; mv I4,I1
	stx A1,(I0)

	ldc 8,A1
	ldx (I4)+6,A0
	add A0,A1,A1
	stx A1,(I1)
LC10:
	ldc 4,A0
	sub C0,A0,A0 ; ldx (I4)-6,NULL
	ldc 1024,A0
	jcc L10	// <
	nop

//   }
//  out:

	ldx (I4)+6,NULL ; ldy (I6)+1,NULL
_LargePageRead_out:
	ldc 49222,I0
	ldy (I4)+1,NULL ; stx A0,(I0)/*V*/

//   *((__x volatile u_int16 *)(u_int16)(  0xC046   ))   = 0x0400  ;
//   return err;

	ldx (I4)-1,A0 ; ldy (I6)-1,NULL	// err
	ldx (I6)-1,LC
	ldx (I6)-1,LE ; ldy (I6),LS
	ldx (I6)-1,I1 ; ldy (I6),I2
	ldx (I6)-1,D1 ; ldy (I6),I0
	ldx (I6)-1,C1 ; ldy (I6),D0
	ldx (I6)-1,B1 ; ldy (I6),C0
	ldx (I6)-1,A1 ; ldy (I6),B0
	ldx (I4),I6 ; ldy (I4),I4	// Read Sp and Fp
	ldx (I6)-1,NULL
	ldx (I6)-1,LR0 ; ldy (I6),I5
	jr
	ldx (I6)-1,MR0 ; ldy (I6),I7
#endif

	.end
