#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>

#include <player.h>
#include <mappertiny.h>
#include <minifat.h>
#include <vsNand.h>
#include <dev1000.h>

//#define DUMP_LARGE_PAGE
//#define DUMP_PHYS
//#define DUMP_FAT
//#define DUMP_DIR
//#define WR_SECTOR
//#define MAP_FMT
#define WR_IMAGE
//#define WR_BITS

#if 0
extern struct FsNandPhys fsNandPhys;
struct FmfMeta {
  u_int16 ecc01;
  u_int16 ecc2AndType;
  u_int16 reservedAndBadBlock;
  u_int16 unused;
  u_int32 logicalPageNo;	/* For root node, this is last used */
  s_int32 newBranch;		/* Page # for root node, non- -1 for others */
};
#define FS_MAP_NON_FULL 4

#define FMF_TYPE_INVALIDATED	  0
#define FMF_TYPE_ROOT		  1
#define FMF_TYPE_BRANCH2	  2
#define FMF_TYPE_BRANCH3	  3
#define FMF_TYPE_BRANCH4	  4
#define FMF_TYPE_DATA		  5
#define FMF_TYPE_UNUSED		255

#define FMF_BRANCH_LEVELS	4
#define FMF_EMPTY_BLOCKS	2
#endif

//s_int16 LargePageWrite(s_int32 page, u_int16 *data, u_int16 *meta);

extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;
//extern struct CodecServices cs;

__y const char hex[] = "0123456789abcdef";
void puthex(u_int16 a) {
  char tmp[8];
  tmp[0] = hex[(a>>12)&15];
  tmp[1] = hex[(a>>8)&15];
  tmp[2] = hex[(a>>4)&15];
  tmp[3] = hex[(a>>0)&15];
  tmp[4] = ' ';
  tmp[5] = '\0';
  fputs(tmp, stdout);
}
void fputhex6(u_int32 a, FILE *fp) {
  char tmp[8];
  tmp[0] = hex[(a>>20)&15];
  tmp[1] = hex[(a>>16)&15];
  tmp[2] = hex[(a>>12)&15];
  tmp[3] = hex[(a>>8)&15];
  tmp[4] = hex[(a>>4)&15];
  tmp[5] = hex[(a>>0)&15];
  tmp[6] = '\0';
  fputs(tmp, fp);
}
void puthex6(u_int32 a) {
    fputhex6(a, stdout);
}
#define NAN 0x80000000L
long GetParam(char *str) {
  static char in[200];
  char *tmp;
  register int i;
  long value;
  if (str) {
    fputs(str, stdout);
    fflush(stdout);
  }
  fgets(in, 200, stdin);
  i = strlen(in);
  while (i && (in[i-1] == '\n' || in[i-1] == '\r'))
    in[--i] = '\0';
  value = strtol(in, &tmp, 0);
  if (!in[0] || (tmp && *tmp && *tmp != '\n' && *tmp != '\r'))
    return NAN;
  return value;
}
void PrintSector(u_int16 *data, u_int16 *spare) {
#if 1
  register int i;
  if (data) {
    puts("d");
    for (i=0;i<256;i++) {
      puthex(data[i]);
      if ((i&7) == 7)
	putchar('\n');
    }
  }
  if (spare) {
    puts("s");
    for (i=0;i<8;i++)
      puthex(spare[i]);
    putchar('\n');
  }
#endif
}

#define NandSelect() USEX(GPIO0_ODATA) &= ~GPIO0_CS1
#define NandDeselect() USEX(GPIO0_ODATA) |= GPIO0_CS1
void NandPutCommand (register __a0 u_int16 command);
void NandPutBlockAddress(register __c u_int32 addr);
void NandPutDataAddress(register __c u_int32 addr);
void NandPutLargePageSpareAddress(register __c u_int32 addr);
u_int16 NandGetStatus(void);
void NandPutAddressOctet(register __a0 u_int16 address);
void NandGetOctets(register __c0 s_int16 length, register __i2 u_int16 *buf);

u_int16 NandGetIdent(void){
  u_int16 ident[4];
  NandDeselect();
  NandSelect();
  NandPutCommand(NAND_OP_READ_SIGNATURE);
  NandPutAddressOctet(0);
  NandGetOctets(8,ident);
  NandDeselect();
  fputs("Nand Signature: ",stdout);
  /*
    2cdc 9095 5400 MT29F4G08AAA
    ecd3 14a5 64ec K9G8G08U0A-PCB0   8Gb MLC  type=3 bl=9 sz=21
    ecd5 55a5 68ec K9LAG08U0A-PCB0  16Gb MLC  type=3 bl=9 sz=22 (2 dies)
    add3 14a5 34ad HY27UT088G2A-TPC8 8Gb MLC  type=3 bl=9 sz=21
    add3 14a5 64ad HY27UU08AG5M          MLC  type=3 bl=9 sz=22(21) (2 /CS, 2 R/B)
  */
  /*
    1st byte: maker code
    2nd byte: device code
    3rd & 4th byte: parameters
   */
#if 1
  {
    register int i;
    for (i=0; i<3; i++){
      puthex(ident[i]);
    }
  }
  fputs("\n",stdout);
#endif

#if 1
  puthex(1 << ((ident[1]>>8) & 3));
  puts("dies");
  puthex(((ident[1] >> 10) & 3) + 1);
  puts("bits/cell");
  puthex(1 << ((ident[1] >> 12) & 3));
  puts("sim.prog.pages");
  puts((ident[1] & 0x4000U) ? "Interleaved program" : "No interleaved program");
  puts((ident[1] & 0x8000U) ? "Cache program" : "No cache program");
  puthex((ident[1] & 3)+1);
  puts("kB page");
  puthex(64 << ((ident[1] >> 4) & 3));
  puts("kB block");
#endif
  return ident[0];
}
#include <audio.h>
#include <player.h>

//#define ECC_TEST
#ifdef ECC_TEST

#if 0 /*now in dev1000.h*/
u_int32 CalcECCBySoftware(register __i2 s_int16 *dp) {
    u_int16 t0, t1;
    register __d0 u_int16 cp = 0;
    register __c u_int32 lp = 0;
    register __d1 s_int16 n;

    for (n=0;n<512/2;n++) {
	t0 = (*dp>>8) ^ (*dp>>9) ^ (*dp>>10) ^ (*dp>>11)
	    ^ (*dp>>12) ^ (*dp>>13) ^ (*dp>>14) ^ (*dp>>15);
	t1 = (*dp>>0) ^ (*dp>>1) ^ (*dp>>2)  ^ (*dp>>3)
	    ^ (*dp>>4) ^ (*dp>>5) ^ (*dp>>6) ^ (*dp>>7);
	lp ^= (t0 & 1) << 0;
	lp ^= (t1 & 1) << 1;
	t0 = (t0 ^ t1) & 1;
	if (!(n & 1)) {
	    lp ^= t0 << 2;
	} else {
	    lp ^= t0 << 3;
	}
	if (!(n & 2)) {
	    lp ^= t0 << 4;
	} else {
	    lp ^= t0 << 5;
	}
	if (!(n & 4)) {
	    lp ^= t0 << 6;
	} else {
	    lp ^= t0 << 7;
	}
	if (!(n & 8)) {
	    lp ^= t0 << 8;
	} else {
	    lp ^= t0 << 9;
	}
	if (!(n & 16)) {
	    lp ^= t0 << 10;
	} else {
	    lp ^= t0 << 11;
	}
	if (!(n & 32)) {
	    lp ^= t0 << 12;
	} else {
	    lp ^= t0 << 13;
	}
	if (!(n & 64)) {
	    lp ^= t0 << 14;
	} else {
	    lp ^= t0 << 15;
	}
	if (!(n & 128)) {
	    lp ^= (u_int32)t0 << 16;
	} else {
	    lp ^= (u_int32)t0 << 17;
	}
	cp ^= (((*dp>>0)^(*dp>>2)^(*dp>>4)^(*dp>>6)
		^(*dp>>8)^(*dp>>10)^(*dp>>12)^(*dp>>14)) & 1) << 0;
	cp ^= (((*dp>>1)^(*dp>>3)^(*dp>>5)^(*dp>>7)
		^(*dp>>9)^(*dp>>11)^(*dp>>13)^(*dp>>15)) & 1) << 1;
	cp ^= (((*dp>>0)^(*dp>>1)^(*dp>>4)^(*dp>>5)
		^(*dp>>8)^(*dp>>9)^(*dp>>12)^(*dp>>13)) & 1) << 2;
	cp ^= (((*dp>>2)^(*dp>>3)^(*dp>>6)^(*dp>>7)
		^(*dp>>10)^(*dp>>11)^(*dp>>14)^(*dp>>15)) & 1) << 3;
	cp ^= (((*dp>>0)^(*dp>>1)^(*dp>>2)^(*dp>>3)
		^(*dp>>8)^(*dp>>9)^(*dp>>10)^(*dp>>11)) & 1) << 4;
	cp ^= (((*dp>>4)^(*dp>>5)^(*dp>>6)^(*dp>>7)
		^(*dp>>12)^(*dp>>13)^(*dp>>14)^(*dp>>15)) & 1) << 5;
	dp++;
    }
    /* ECC0 : lp[7:0]
       ECC1 : lp[15:8]
       ECC2 : cp[5:0] lp[17:16] */
    return lp | (u_int32)cp << 18;
}
#endif

void ECCTest(u_int16 *data, u_int16 *spare) {
    u_int32 ecc;
    u_int16 t0, t1;

    ecc = CalcECCBySoftware((void *)data);

    puthex(spare[0]);
    puthex(spare[1]);
    putchar(' ');
    t0 = ecc;
    t1 = ((ecc>>8) & 0xff00U) | 0xff;
    puthex(t0);
    puthex(t1);
    if (t0 == spare[0] && t1 == spare[1]) {
	puts("=");
    } else {
	puts("**!!");
    }
}
#endif


char in[200];
void main(void) {
    //ph = FsPhNandCreate(1);
#if 1
    clockX = 7;
//    SetRate(1000);

    voltages[voltIoPlayer] = 30;
    PowerSetVoltages(&voltages[voltCorePlayer]);
#endif

#if 0
    /* In case we have parallel display, deassert CS */
    PERIP(GPIO0_DDR) |= 0x4000;
    PERIP(GPIO0_SET_MASK) = 0x4000; //CS2
#endif

#if 1
    ((struct FsNandPhys *)ph)->nandType = 3;
    ((struct FsNandPhys *)ph)->waitns = 300;
#endif
//    puthex(((struct FsNandPhys *)ph)->nandType);
//    puts("=nT");
    puthex(((struct FsNandPhys *)ph)->waitns);
    puts("=ws");
    puthex6(ph->eraseBlockSize);
    puts("=eraseBlockSize");
    puthex6(ph->eraseBlocks);
    puts("=eraseBlocks");
    NandGetIdent();

//#define VERIFY_ONLY
    /* write image */
    {
	FILE *fp;
	int i;
	int errs;
    again:
	errs = 0;
	fp = fopen("boot.img", "rb");
	if (fp) {
	    u_int32 sector = 0;
#ifndef VERIFY_ONLY
	    ph->Erase(ph, 0);
#endif
	    puts("Writing");
	    PERIP(INT_ENABLEL) &= ~INTF_RX;
	    memset(mallocAreaX, -1, 2048/2);
#ifndef VERIFY_ONLY
	    while (fread(mallocAreaX, 1, 2048/2, fp)) {
		memset(minifatBuffer, -1, 4*16/2);
		if (LargePageWrite(sector, mallocAreaX, minifatBuffer)) {
		    puts("WrError");
		}
		for (i=0;i<256;i++) {
		    BusyWait10();
		}

		sector += 4;
		memset(mallocAreaX, -1, 2048/2);
	    }
	    //fclose(fp);
	    puthex(sector);
	    puts("=sectors written");
#endif
	    fseek(fp, 0, SEEK_SET);
	    sector = 0;

	    puts("Verifying");
	    while (fread(mallocAreaX, 1, 512/2, fp)) {
		if (ph->Read(ph, sector, 1, mallocAreaX+256, minifatBuffer) != 1)
		    puts("read error");
#ifdef ECC_TEST
		ECCTest(mallocAreaX+256, minifatBuffer);
#endif
		if (memcmp(mallocAreaX, mallocAreaX+256, 512/2)) {
		    puthex(sector);
		    puts("verify error");
		    for (i=0;i<256;i++) {
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    errs++;
			}
#if 0 //ndef VERIFY_ONLY
			if (mallocAreaX[i] != mallocAreaX[256+i]) {
			    puthex(i);
			    puthex(mallocAreaX[i]);
			    puthex(mallocAreaX[256+i]);
			    puts("");
			}
#endif
		    }
		}
		sector += 1;
		memset(mallocAreaX, -1, 512/2);
	    }
	    fclose(fp);
	    PERIP(INT_ENABLEL) |= INTF_RX;
	}
	if (errs) {
	    puthex(errs);
	    puts("=errs, trying again");
	    ((struct FsNandPhys *)ph)->waitns++;
	    goto again;
	}
    }
    puts("Finished");
    ((void (*)(void))(0x4000))(); /*jump to start*/
}
